#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>

HWND hWndFontFamily;	//   " "   
HWND hWndFontSize;		//   " "   
HWND hWndText;			//   "  "   

//        
void Draw (HDC hDC, LOGFONT* lf, LPCTSTR text, RECT* rc)
{
	//    
	HFONT hFont = CreateFontIndirect (lf);
	HFONT hOldFont = (HFONT) SelectObject (hDC, hFont);
	//   
	int iOldMode = SetBkMode (hDC, TRANSPARENT);
	COLORREF clrOldColor = SetTextColor (hDC, GetSysColor (COLOR_BTNSHADOW));
	DrawText (hDC, text, -1, rc, DT_SINGLELINE | DT_CENTER | DT_VCENTER);
	//  
	SetTextColor (hDC, GetSysColor (COLOR_BTNTEXT));
	OffsetRect (rc, -2, -2);
	DrawText (hDC, text, -1, rc, DT_SINGLELINE | DT_CENTER | DT_VCENTER);
	//   
	SetTextColor (hDC, clrOldColor);
	SetBkMode (hDC, iOldMode);
	SelectObject (hDC, hOldFont);
	DeleteObject (hFont);
}

//      EnumFontFamiliesEx   
//   " "     
int CALLBACK EnumFontFamExProc (ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *, DWORD, LPARAM)
{
	SendMessage (hWndFontFamily, CB_ADDSTRING, 0, (LPARAM)lpelfe->elfLogFont.lfFaceName);
	return 1;
}

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
		case WM_CREATE:
		{
			//    " "   
			CREATESTRUCT* cs = (CREATESTRUCT*) lParam;
			hWndFontFamily = CreateWindowEx (WS_EX_CLIENTEDGE, "COMBOBOX", NULL,
				WS_CHILDWINDOW | WS_BORDER | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL |
				CBS_AUTOHSCROLL | CBS_DROPDOWNLIST | CBS_HASSTRINGS | CBS_SORT,
				5, 5, 200, 300, hWnd, (HMENU) 100, cs->hInstance, 0);
			LOGFONT lf;
			ZeroMemory (&lf, sizeof (lf));
			lf.lfCharSet = RUSSIAN_CHARSET;
			HDC hDC = GetDC (hWnd);
			EnumFontFamiliesEx (hDC, &lf, (FONTENUMPROC) EnumFontFamExProc, 0, 0);
			ReleaseDC (hWnd, hDC);
			SendMessage (hWndFontFamily, CB_SETCURSEL, 0, 0);			
			//    " "   
			hWndFontSize = CreateWindowEx (WS_EX_CLIENTEDGE, "COMBOBOX", NULL,
				WS_CHILDWINDOW | WS_BORDER | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL |
				CBS_AUTOHSCROLL | CBS_DROPDOWNLIST | CBS_HASSTRINGS,
				5, 35, 200, 300, hWnd, (HMENU) 101, cs->hInstance, 0);
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) " 6 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) " 8 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "10 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "12 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "14 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "16 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "18 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "24 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "32 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "48 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "72 pt");
			SendMessage (hWndFontSize, CB_ADDSTRING, 0, (LPARAM) "96 pt");
			SendMessage (hWndFontSize, CB_SETCURSEL, 5, 0);	//   16 pt
			//    "  "   
			hWndText = CreateWindowEx (WS_EX_CLIENTEDGE, "EDIT", NULL,
				WS_CHILDWINDOW | WS_BORDER | WS_VISIBLE | WS_TABSTOP |
				ES_LEFT | ES_AUTOHSCROLL,
				5, 65, 400, 24, hWnd, (HMENU) 102, cs->hInstance, 0);
			SetWindowText (hWndText, "       ");
			return 0;
		}

		case WM_COMMAND:
			//     - 
			if (HIWORD (wParam) == EN_UPDATE || HIWORD (wParam) == CBN_SELCHANGE) {
				InvalidateRect (hWnd, NULL, TRUE);
				UpdateWindow (hWnd);
			}
			break;

		case WM_PAINT:
			//  
			if (GetUpdateRect (hWnd, NULL, FALSE)) {
				PAINTSTRUCT ps;
				BeginPaint (hWnd, &ps);
				//      
				LOGFONT lf;
				ZeroMemory (&lf, sizeof (lf));
				char size [100];
				GetWindowText (hWndFontSize, size, sizeof (size));
				lf.lfHeight = atoi (size);
				lf.lfCharSet = RUSSIAN_CHARSET;
				lf.lfQuality = ANTIALIASED_QUALITY;
				GetWindowText (hWndFontFamily, lf.lfFaceName, sizeof (lf.lfFaceName));
				char text [100];
				GetWindowText (hWndText, text, sizeof (text));
				RECT rc;
				GetClientRect (hWnd, &rc);
				rc.top = 100;
				//  
				Draw (ps.hdc, &lf, text, &rc);
				EndPaint (hWnd, &ps);
			}
			return 0;

		case WM_DESTROY:
			PostQuitMessage (0);
			return 0;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE, LPTSTR, int)
{
	//   
	WNDCLASSEX wcex;
	ZeroMemory (&wcex, sizeof (wcex));
	wcex.cbSize = sizeof (WNDCLASSEX); 
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = WndProc;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon (NULL, IDI_ASTERISK);
	wcex.hCursor = LoadCursor (NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
	wcex.lpszClassName = "lb041221";
	if (RegisterClassEx (&wcex)) {
		//  
		HWND hWnd = CreateWindowEx (WS_EX_APPWINDOW,
			wcex.lpszClassName, wcex.lpszClassName,
			WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_VISIBLE,
			CW_USEDEFAULT, CW_USEDEFAULT, 600, 400,
			GetDesktopWindow (), NULL, hInstance, NULL);
		if (hWnd) {
			//  
			ShowWindow (hWnd, SW_NORMAL);
			UpdateWindow (hWnd);
			//   
			MSG msg;
			while (GetMessage (&msg, NULL, 0, 0)) {
				TranslateMessage (&msg);
				DispatchMessage (&msg);
			}
		}
	}
	return 0;
}
